//Disable $fn and $fa, do not change these
$fn=0;
$fa=0.01;
$fs=0.5;


m2=3.0;

module nut()
{
    rotate([0,0,30])cylinder(5,r = 5.5 / 2 / cos(180 / 6) + 0.2, $fn=6);
}


raild=8.5;


blockx=20;
blocky=15;
blockz=17-3.5+3;
blockzpad=3+1.5-3.5/2-0.5;

backx=54+(blockx-raild)-2*blockx;
backy=blocky;
backz=3;


// rod centre at 
// blockz/2+blockzpad
// (17-3.5+3)/2+3+(1.5-3.5/2);

// was
// (17-3.5)/2+3-3.5/2;


module bearingblock()
{
 difference()
    {
     cube([blockx,blocky,blockz]);
     translate([blockx/2,blocky+0.25,blockz/2+blockzpad])   rotate([90,0,0])cylinder(blocky+0.5,d=raild);
     translate([4,blocky/2,0])cylinder(blockz,d=m2);
     translate([4,blocky/2,0])nut();   
        
     translate([blockx-4,blocky/2,0])cylinder(blockz,d=m2);
    translate([blockx-4,blocky/2,0])nut();           
        
        
    }
    
}




tabz=10-3-0.5;
taby=17;
tabx=1.5;


module endstop()
{
union()
{
 translate([blockx,0,0])cube([backx,backy,backz]);

 translate([0,0,0])bearingblock();
 translate([backx+blockx,0,0])bearingblock();
 translate([backx/2+blockx-tabx/2,0,0])cube([tabx,taby+blocky,tabz]);   
}

}

// top

translate([0,0,10])intersection()
{
 translate([0,0,blockz/2+blockzpad+1])cube([2*blockx+backx,blocky+taby,blockz]);
 endstop();
}

// bottom

intersection()
{
 translate([0,0,-(blockz-(blockz/2+blockzpad))])cube([2*blockx+backx,blocky+taby,blockz]);
 endstop();
}




